# See LICENSE file for full copyright and licensing details.

from odoo import models, api
import logging
import requests
import time

_logger = logging.getLogger(__name__)

try:
    import dropbox
except ImportError:
    _logger.debug(ImportError)


class UtilsUtils(models.TransientModel):
    _name = 'utils.utils'
    _description = 'Utils'

    @api.model
    def connection(self, key):
        count = 1
        dpx = False
        while not dpx:
            try:
                dpx = dropbox.Dropbox(key)
                dpx.users_get_current_account()
            except requests.exceptions.ConnectionError as Ex:
                logging.error(
                    "Dropbox Connection problem Trying Again %s" % count)
                count += 1
                time.sleep(2)
                if count > 10:
                    self.logFunc('Error While Connection %s' % Ex, error=True)
                    return False
                continue
            except Exception as Ex:
                self.logFunc('Error While Connection %s' % Ex, error=True)
                return False
        return dpx

    @api.model
    def logFunc(self, log, error=False):
        if error:
            _logger.error(log)
        else:
            _logger.info(log)

    @api.model
    def folderList(self, dpx, recursive):
        try:
            folder_list = dpx.files_list_folder('', True).entries
        except Exception as Ex:
            self.logFunc('Error while Getting Folder %s' % Ex)
            return False
        return folder_list
